
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "LCD.h"

typedef struct pozitie {

	int x;
	int y;

} pozitie;


pozitie snake[50];
int len = 3;
int directie;
char buton[10];
int end = 0;

pozitie food;
int puncte;
char scor[10];

void init_buttons(void) {

    DDRA = 0xff;
    PORTA = 0x00;
	
	// SUS
    DDRA &= ~(1 << PA0);
    PORTA |= (1 << PA0);
	
	
    // DREAPTA
    DDRA &= ~(1 << PA1);
    PORTA |= (1 << PA1);

    // STANGA
    DDRA &= ~(1 << PA2);
    PORTA |= (1 << PA2);
    
    // JOS
    DDRA &= ~(1 << PA3);
    PORTA |= (1 << PA3); 
   
    
}


void check_input(void) {

	// SUS
    if (!(PINA & (1 << PA0))) {
		directie = 0;
		_delay_ms(100);
    }
    
	// DREAPTA
    if (!(PINA & (1 << PA1))) {
		directie = 1;
		_delay_ms(100);
    }
    
	// STANGA
    if (!(PINA & (1 << PA2))) {
		directie = 2;
		_delay_ms(100);
    }
    
	// JOS
    if (!(PINA & (1 << PA3))) {
		directie = 3;
		_delay_ms(100);
    }
}

void pozitia_initiala(){

	snake[0].x = 4;
	snake[0].y = 5;
	snake[1].x = 4;
	snake[1].y = 6;
	snake[2].x = 4;
	snake[2].y = 7;
	
	len = 3;
	directie = 1;
	
	lcd_goto_xy(snake[0].y,snake[0].x);
	lcd_chr('m');
	lcd_goto_xy(snake[1].y,snake[1].x);
	lcd_chr('m');
	lcd_goto_xy(snake[2].y,snake[2].x);
	lcd_chr('m');


}

void move(){

	int i;
	int ok = 0;
	
	if(directie == 1){  // DREAPTA
	
		for(i = 0; i < len - 1; i++){
		
			snake[i].x = snake[i + 1].x;
			snake[i].y = snake[i + 1].y;
			
			lcd_goto_xy(snake[i].y,snake[i].x);
			lcd_chr('m');
			
		}
		
		snake[len - 1].y ++;
		
		for(i = 0; i < len - 1; i++)
			if(snake[i].x == snake[len - 1].x && snake[i].y == snake[len - 1].y)
				ok = 1;
		
		if(ok == 0){
			if(snake[len - 1].y == 15)
				snake[len - 1].y = 1;
		
			lcd_goto_xy(snake[len - 1].y,snake[len - 1].x);
			lcd_chr('m');
			
		} else {
		
			lcd_clear();
			lcd_goto_xy(4,3);
			lcd_str("GAME OVER");
			
			itoa(puncte,scor,10);
			lcd_goto_xy(7,4);
			lcd_str(scor);
			end = 1;	
		}
		
	
	} else if(directie == 2){  // STANGA
	
		for(i = 0; i < len - 1; i++){
		
			snake[i].x = snake[i + 1].x;
			snake[i].y = snake[i + 1].y;
			
			lcd_goto_xy(snake[i].y,snake[i].x);
			lcd_chr('m');	
		}
		
		snake[len - 1].y --;

		for(i = 0; i < len - 1; i++)
			if(snake[i].x == snake[len - 1].x && snake[i].y == snake[len - 1].y)
				ok = 1;	
		
		if(ok == 0){
			if(snake[len - 1].y == 0)
				snake[len - 1].y = 14;
		
			lcd_goto_xy(snake[len - 1].y,snake[len - 1].x);
			lcd_chr('m');
			
		} else {
		
			lcd_clear();
			lcd_goto_xy(4,3);
			lcd_str("GAME OVER");
			
			itoa(puncte,scor,10);
			lcd_goto_xy(7,4);
			lcd_str(scor);
			end = 1;
		}
		
	} else if(directie == 0){ // SUS
	
		for(i = 0; i < len - 1; i++){
		
			snake[i].x = snake[i + 1].x;
			snake[i].y = snake[i + 1].y;
			
			lcd_goto_xy(snake[i].y,snake[i].x);
			lcd_chr('m');
			
		}
		
		snake[len - 1].x --;
		
		for(i = 0; i < len - 1; i++)
			if(snake[i].x == snake[len - 1].x && snake[i].y == snake[len - 1].y)
				ok = 1;
		
		if(ok == 0){
			if(snake[len - 1].x == 0)
				snake[len - 1].x = 6;
		
			lcd_goto_xy(snake[len - 1].y,snake[len - 1].x);
			lcd_chr('m');
			
		} else {
		
			lcd_clear();
			lcd_goto_xy(4,3);
			lcd_str("GAME OVER");
			
			itoa(puncte,scor,10);
			lcd_goto_xy(7,4);
			lcd_str(scor);
			
			end = 1;
		}
			
	} else if(directie == 3){ // JOS
	
		for(i = 0; i < len - 1; i++){
		
			snake[i].x = snake[i + 1].x;
			snake[i].y = snake[i + 1].y;
			
			lcd_goto_xy(snake[i].y,snake[i].x);
			lcd_chr('m');
			
		}
		
		snake[len - 1].x ++;
		
		for(i = 0; i < len - 1; i++)
			if(snake[i].x == snake[len - 1].x && snake[i].y == snake[len - 1].y)
				ok = 1;
			
		if(ok == 0){
			if(snake[len - 1].x == 7)
				snake[len - 1].x = 1;
		
			lcd_goto_xy(snake[len - 1].y,snake[len - 1].x);
			lcd_chr('m');
			
		} else {
		
			lcd_clear();
			lcd_goto_xy(4,3);
			lcd_str("GAME OVER");
			
			itoa(puncte,scor,10);
			lcd_goto_xy(7,4);
			lcd_str(scor);
			end = 1;
		}
	}

}

void put_food(){

	int ok = 0;
	int i;
	
	while(ok == 0){
	
		food.x = rand() % 6 + 1;
		food.y = rand() % 13 + 1;
		
		ok = 1;
		for(i = 0; i < len - 1; i++)
			if(food.x == snake[i].x && food.y == snake[i].y)
				ok = 0;
	
	}
}

void eat(){

	if(snake[len - 1].x == food.x && snake[len - 1].y == food.y){
		food.x = 0;
		food.y = 0;
		len ++;
		snake[len - 1].x = snake[len - 2].x;
		snake[len - 1].y = snake[len - 2].y;
		puncte = puncte + 5;
	}
}

int main(void){
	
	lcd_init();
	lcd_contrast(0x40);
	
	lcd_goto_xy(1,1);
	init_buttons();
	
	pozitia_initiala();
	put_food();
	lcd_goto_xy(food.y,food.x);
	lcd_chr('*');
	_delay_ms(300);
	
	
	while(end == 0){
		
		lcd_clear();
		
		if(food.x == 0)
			put_food();
			
		lcd_goto_xy(food.y,food.x);
		lcd_chr('*');
		
		move();
		eat();
		check_input();
		
		_delay_ms(200);
		
	}

}

